﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'Custom View class
#Event:Click
#RaisesSynchronousEvents:Click
#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: Text, Description: Text of the button.
#DesignerProperty: Key: TextSize, DisplayName: TextSize, FieldType:int, DefaultValue: 12, List:9|10|11|12|13|14|15|16|17||18|19|20
#DesignerProperty: Key: ButtonType, DisplayName: ButtonType, FieldType: string, DefaultValue: ImageTop,List:ImageTop|ImageLeft ,Description: Select the buttton type.
#DesignerProperty: Key: ImageFile, DisplayName: ImageFile, FieldType:string, DefaultValue: shouru.png, List:shouru.png|shouzhifl.png|calculator.png|time.png|liushuiz.png|zhichu.png|ndhuizong.png|rjb.png

Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Public Tag As Object
	
	Private mLeft, mTop, mWidth, mHeight As Int
	Private mText,mButtonType,mImageFile,mImagePath As String
	Private mIcon As B4XBitmap
	Private mParent As B4XView	
	Private mTextSize,mImageSize,mlbWidth,mlbHeight As Double
	Private mImg As ImageView
	Private mLbl As Label
	Private mFont As B4XFont
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback	
		
	mText="Text"
	mFont=xui.CreateDefaultFont(12)	
	mTextSize=12
	mImageFile="shouru.png"
	mImagePath=File.DirApp&"\ico"	
	mButtonType="ImageTop"
	mImageSize=IIf(mButtonType="ImageTop",mTextSize*2,mTextSize)
	mIcon=xui.LoadBitmapResize(mImagePath,mImageFile,mImageSize,mImageSize,True)
	mImg.Initialize("mImg")
	mLbl.Initialize("mLbl")
End Sub

Public Sub DesignerCreateView (Base As Pane, lbl As Label, Props As Map)
	
	Private mDummy As B4XView
	mDummy = Base
	mLeft = mDummy.Left
	mTop = mDummy.Top
	mWidth = mDummy.Width
	mHeight = mDummy.Height
	Tag = mDummy.Tag	
	mText = Props.Get("Text")	
	mImageFile=Props.Get("ImageFile")
	mTextSize=Props.Get("TextSize")
	mButtonType = Props.Get("ButtonType")	
	mImageSize=IIf(mButtonType="ImageTop",mTextSize*2,mTextSize)
	mIcon=xui.LoadBitmapResize(mImagePath,mImageFile,mImageSize,mImageSize ,True)
	mBase = xui.CreatePanel("mBase")		
	mParent = mDummy.Parent
	mParent.AddView(mBase, mLeft, mTop, mWidth, mHeight)
	mBase.Tag = Me	
	mDummy.RemoveViewFromParent	
	InitClass
End Sub

Public Sub GetBase As Object
	Return mBase
End Sub

Public Sub AddToParent(Parent As Object, Left As Int, Top As Int, Width As Int, Height As Int)
	mLeft = Left
	mTop = Top
	mWidth = Width
	mHeight = Height
	mParent = Parent	
	mBase = xui.CreatePanel("mBase")	
	mParent.AddView(mBase, mLeft, mTop, mWidth, mHeight)
	mBase.Tag = Me	
	InitClass
End Sub

Private Sub InitClass
	
	mImageSize=IIf(mButtonType="ImageTop",mTextSize*2,mTextSize)
	mIcon=xui.LoadBitmapResize(mImagePath,mImageFile,mImageSize,mImageSize ,True)
	mImg.SetImage(mIcon)
	
	mLbl.Text=mText
	mLbl.Font=mFont
	mLbl.TextSize=mTextSize
	
	
	If mButtonType="ImageTop" Then	
		mLbl.Alignment="CENTER"
		mImageSize=mTextSize*2
		mImg.SetSize(mImageSize,mImageSize)
		mlbWidth=mWidth
		mlbHeight=mTextSize+mTextSize/2
		mLbl.SetSize(mlbWidth,mlbHeight)
		mBase.AddView(mImg,(mWidth-mImageSize)/2,(mHeight-mImageSize-mlbHeight-mTextSize/10)/2,mImageSize,mImageSize)
		mBase.AddView(mLbl,0,mImg.Top+mImageSize+mTextSize/10,mWidth,mlbHeight)
	Else
		mLbl.Alignment="CENTER_LEFT"
		mImageSize=mTextSize
		mImg.SetSize(mImageSize,mImageSize)
		mlbWidth=mWidth-mImageSize-10
		mlbHeight=mTextSize+10
		mLbl.SetSize(mlbWidth,mlbHeight)
		mBase.AddView(mImg,(mWidth-mlbWidth-mImageSize-mTextSize/4)/2,(mHeight-mImageSize)/2,mImageSize,mImageSize)
		mBase.AddView(mLbl,mImg.Left+mImageSize+mTextSize/4,(mHeight-mlbHeight)/2,mlbWidth,mlbHeight)
		
	End If	
	mBase.TextSize=mTextSize
	mBase.Top=mTop
	mBase.Left=mLeft
	mBase.Width=mWidth
	mBase.Height=mHeight
	mBase.As(Pane).StyleClasses.Add("TransparentButton")
	mBase.Tag = Me	
End Sub

Private Sub mBase_Touch (Action As Int, X As Float, Y As Float)
	Select Action		
		Case mBase.TOUCH_ACTION_UP
			If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
				CallSubDelayed(mCallBack, mEventName & "_Click")				
			End If
	End Select
End Sub

Public Sub setText(Text As String)
	mText = Text
	mLbl.Text=mText
End Sub

Public Sub getText As String
	Return mText
End Sub

Public Sub setLeft(Left As Double)
	mLeft = Left	
	mParent=mBase.Parent	
	mBase.RemoveViewFromParent
	mParent.AddView(mBase,mLeft,mTop,mWidth,mHeight)
End Sub

Public Sub getLeft As Double
	Return mLeft
End Sub

Public Sub setTop(Top As Double)
	mTop = Top	
	mParent=mBase.Parent
	mBase.RemoveViewFromParent
	mParent.AddView(mBase,mLeft,mTop,mWidth,mHeight)
End Sub

Public Sub getTop As Double
	Return mTop
End Sub

Public Sub setWidth(Width As Double)
	mWidth =Width	
	mParent=mBase.Parent
	mImg.RemoveNodeFromParent
	mLbl.RemoveNodeFromParent
	mBase.RemoveViewFromParent
	mParent.AddView(mBase,mLeft,mTop,mWidth,mHeight)
	InitClass
End Sub

Public Sub getWidth As Double
	Return mWidth
End Sub

Public Sub setHeight(Height As Double)
	mHeight =Height	
	mImg.RemoveNodeFromParent
	mLbl.RemoveNodeFromParent
	mBase.RemoveViewFromParent
	mParent.AddView(mBase,mLeft,mTop,mWidth,mHeight)
	InitClass	
End Sub

Public Sub getHeight As Double
	Return mHeight
End Sub

Public Sub setImageFile(ImageFile As String)	
	If File.Exists(mImagePath,ImageFile) Then
		mImageFile =ImageFile
		mIcon=xui.LoadBitmapResize(mImagePath,mImageFile,mImageSize,mImageSize ,True)
		mImg.SetImage(mIcon)
	Else
		xui.MsgboxAsync("图像文件不存在！","提示")
		Return
	End If	
End Sub

Public Sub getImageFile As String
	Return mImageFile
End Sub

Public Sub setImagePath(ImagePath As String)	
	If File.Exists(ImagePath,"")=False Then
		xui.MsgboxAsync("您设置的图像文件路径不存在！","提示")
		Return
	End If
	mImagePath=ImagePath
End Sub

Public Sub getImagePath As String
	Return mImagePath
End Sub

Public Sub setTextSize(TextSize As Double)
	mTextSize =TextSize	
	mImg.RemoveNodeFromParent
	mLbl.RemoveNodeFromParent
	mBase.RemoveViewFromParent
	mParent.AddView(mBase,mLeft,mTop,mWidth,mHeight)
	InitClass
End Sub

Public Sub getTextSize As Double
	Return mTextSize
End Sub

Public Sub getButtonType As String
	Return mButtonType
End Sub

Public Sub setFont(Font As B4XFont)
	mFont=Font
	mLbl.Font=mFont
	mLbl.TextSize=mTextSize
End Sub

Public Sub getFont As B4XFont
	Return mFont
End Sub